;VERSION:001
;NEXT VERSION:

.model tiny
.code
.486

mode    struc
        flag    db 0
        num     dw 0
        resx    dw 0
        resy    dw 0
        attr    db 0
mode    ends

body:
     finit
     mov ax,4f02h
     mov bx,105h
     int 10h

     mov cs:word ptr color,12
     mov cs:word ptr maxx,1024
     mov cs:word ptr maxy,768

     mov ax,cs
     mov cs:word ptr drvadr+2,ax
     lea ax,driver
     mov cs:word ptr drvadr,ax

     push cs
     pop es
     push cs
     pop ds

     lea di,fnt
     mov cx,8
     mov dx,16
     call settext

     lea si,txt
     mov cx,360
     mov dx,372
     call outtext

     mov cx,512
     mov dx,380
     mov ax,90
     mov bx,30
     call ellipse

;     mov ax,10
;     mov bx,10
;     mov cx,500
;     mov dx,200
;     call bar

;     mov ax,5
;     mov bx,5
;     mov cx,150
;     mov dx,150
;     call rectangle


     mov ax,4c00h
     int 21h


gproc:
        cmp ax,0                ;Get info
        jne gp0
        mov cx,cs:word ptr maxx
        mov dx,cs:word ptr maxy
        mov si,4h
        mov di,103h
        retf
gp0:
        cmp ax,1                ;Set mode
        jne gp1
        call setmode
        retf
gp1:
        cmp ax,2                ;Driver interface (internal)
        jne gp2
        retf
gp2:
        cmp ax,3                ;Put pixel
        jne gp3
        call putcpixel
        retf
gp3:
        cmp ax,4                ;Get pixel
        jne gp4
        retf
gp4:
        cmp ax,5                ;Set color
        jne gp5
        retf
gp5:

        cmp ax,100h              ;Line
        jne gp100
        call line
        retf
gp100:
        cmp ax,101h              ;Barfill
        jne gp101
        call barfill
        retf
gp101:
        cmp ax,102h              ;Bar
        jne gp102
        call bar
        retf
gp102:
        cmp ax,103h              ;Circle
        jne gp103
        call circle
        retf
gp103:
        cmp ax,104h              ;ellipse
        jne gp104
        call ellipse
        retf
gp104:
        cmp ax,105h              ;rectangle
        jne gp105
        call rectangle
        retf
gp105:

        cmp ax,200h              ;Set text
        jne gp200
        call settext
        retf
gp200:
        cmp ax,201h              ;Get text
        jne gp201
        call gettext
        retf
gp201:
        cmp ax,202h              ;Out char
        jne gp202
        call outchar
        retf
gp202:
        cmp ax,203h              ;Out text
        jne gp203
        call outtext
        retf
gp203:


        retf

;---------------DRVProcs---------------
setmode:         ;CX,DX = Resolution Bl = Attribute
     push ax
     mov ax,10h
     call cs:dword ptr drvadr
     cmp ax,0
     jne m15
     mov cs:word ptr maxx,cx
     mov cs:word ptr maxy,dx
m15:
     pop ax
     ret

putpixel:
     push ax
     mov ax,cs:word ptr color
     call putcpixel
     pop ax
     ret

putcpixel:
     push bx
     mov bx,ax
     mov ax,0
     call cs:dword ptr drvadr
     pop bx
     ret

getpixel:
     push bx
     mov bx,ax
     mov ax,1
     call cs:dword ptr drvadr
     pop bx
     ret

;-------------Copyright----------------
        db 10,'Copyright (C) 1998 EXOS Technologies.'
        db 10,'Extended operation system verion 1.0 beta.'
        db 10,'All rights reseved.'
        db 10

;---------------Procedurs--------------
line:pusha
     cmp ax,cx    ;(AX,BX)-(CX,DX)
     je vline
     cmp bx,dx
     je hline

     mov cs:word ptr w0,ax
     mov cs:word ptr w1,bx
     sub cs:word ptr w0,cx
     sub cs:word ptr w1,dx
     fild cs:word ptr w1
     fidiv cs:word ptr w0
     fst cs:qword ptr q0   ;K

     mov cs:word ptr w0,ax
     mov cs:word ptr w1,bx
     fimul cs:word ptr w0
     fisub cs:word ptr w1
     fchs
     fstp cs:qword ptr q1  ;B

     mov cs:word ptr w0,ax
     sub cs:word ptr w0,cx
     mov cs:word ptr w1,bx
     sub cs:word ptr w1,dx
     push ax
     mov ax,cs:word ptr w1
     cmp cs:word ptr w0,ax
     jg m3

     pop ax     ;for X
m4:  mov cs:word ptr w0,cx
     fild cs:word ptr w0
     fmul cs:qword ptr q0
     fadd cs:qword ptr q1
     fistp cs:word ptr w0
     mov dx,cs:word ptr w0
     call putpixel
     dec cx
     cmp ax,cx
     jle m4
     popa
     ret
m3:
     pop ax     ;for Y
m5:  mov cs:word ptr w0,dx
     fild cs:word ptr w0
     fmul cs:qword ptr q0
     fadd cs:qword ptr q1
     fistp cs:word ptr w0
     mov cx,cs:word ptr w0
     call putpixel
     dec dx
     cmp bx,dx
     jle m5
     popa
     ret

vline:            ;Vertical
     cmp bx,dx
     jl m1
     xchg bx,dx
m1:
     call putpixel
     dec dx
     cmp bx,dx
     jle m1
     popa
     ret

hline:            ;Horizontal
     cmp ax,cx
     jl m2
     xchg ax,cx
m2:
     call putpixel
     dec cx
     cmp ax,cx
     jle m2
     popa
     ret
;---------------------
rectangle:                      ;(AX,BX)-(CX,DX)
     push dx
     mov dx,bx
     call line
     pop dx

     push cx
     mov cx,ax
     call line
     pop cx

     push ax
     mov ax,cx
     call line
     pop ax

     push bx
     mov bx,dx
     call line
     pop bx

     ret

;---------------------
barfill:                        ;(AX,BX)-(CX,DX)
     pusha                      ;ES:DI = Fill(X(dw),Y(dw),fill))
     mov cs:word ptr w6,ax
     mov cs:word ptr w0,ax
     mov cs:word ptr w1,bx
     mov cs:word ptr w2,cx
     mov cs:word ptr w3,dx
     mov ax,es:[di]
     mov bx,es:[di+2]
     mov cs:word ptr w4,ax
     mov cs:word ptr w5,bx

m6:
     mov ax,cs:word ptr w0
     xor dx,dx
     div cs:word ptr w4
     push dx
     mov ax,cs:word ptr w1
     xor dx,dx
     div cs:word ptr w5
     mov ax,cs:word ptr w4
     mul dx         ;DX  뢠
     pop dx
     add ax,dx
     add ax,di
     add ax,4
     mov bx,ax
     mov ax,es:[bx]

     mov cx,cs:word ptr w0
     mov dx,cs:word ptr w1
     call putcpixel

     inc cx
     mov cs:word ptr w0,cx
     cmp cx,cs:word ptr w2
     jle m6

     inc dx
     mov cs:word ptr w1,dx
     mov ax,cs:word ptr w6
     mov cs:word ptr w0,ax
     cmp dx,cs:word ptr w3
     jle m6

     popa
     ret

;---------------------
bar:                                ;(AX,BX)-(CX,DX)
     pusha
     mov cs:word ptr w0,ax
     xchg ax,cx
     xchg bx,dx
m7:
     call putpixel

     inc cx
     cmp cx,ax
     jle m7

     inc dx
     mov cx,cs:word ptr w0
     cmp dx,bx
     jle m7

     popa
     ret


;---------------------
circle:                ;(CX,DX)-BX
     pusha
     pushf
     mov cs:word ptr w0,cx
     mov cs:word ptr w1,dx
     mov cs:word ptr w2,bx
     fld cs:qword ptr pi2
     fidiv cs:word ptr w2
     fstp cs:qword ptr q1
     fldz
     fstp cs:qword ptr q0
m8:
     fld cs:qword ptr q0
     fsincos
     fimul cs:word ptr w2
     fistp cs:word ptr w3
     mov cx,cs:word ptr w3
     fimul cs:word ptr w2
     fistp cs:word ptr w3
     mov dx,cs:word ptr w3
     add cx,cs:word ptr w0
     add dx,cs:word ptr w1
     call putpixel

     fld cs:qword ptr q0
     fadd cs:qword ptr q1
     fcom cs:qword ptr pi_2
     fstp cs:qword ptr q0
     fstsw ax
     sahf
     jb m8

     popf
     popa
     ret

;---------------------
ellipse:                ;(CX,DX)-(AX,BX radius)
     pusha
     pushf
     mov cs:word ptr w0,cx
     mov cs:word ptr w1,dx
     mov cs:word ptr w2,bx
     mov cs:word ptr w4,ax
     cmp ax,bx
     jg m13
     fld cs:qword ptr pi2
     fidiv cs:word ptr w2
     fstp cs:qword ptr q1
     fldz
     fstp cs:qword ptr q0
m13:
     fld cs:qword ptr pi2
     fidiv cs:word ptr w4
     fstp cs:qword ptr q1
     fldz
     fstp cs:qword ptr q0
m14:
     fld cs:qword ptr q0
     fsincos
     fimul cs:word ptr w4
     fistp cs:word ptr w3
     mov cx,cs:word ptr w3
     fimul cs:word ptr w2
     fistp cs:word ptr w3
     mov dx,cs:word ptr w3
     add cx,cs:word ptr w0
     add dx,cs:word ptr w1
     call putpixel

     fld cs:qword ptr q0
     fadd cs:qword ptr q1
     fcom cs:qword ptr pi_2
     fstp cs:qword ptr q0
     fstsw ax
     sahf
     jb m14

     popf
     popa
     ret

;---------------------
settext:             ;CX,DX=char size ES:DI=font addres
     pusha
     mov cs:byte ptr charx,cl
     mov cs:byte ptr chary,dl
     mov cs:word ptr font,di
     mov ax,es
     mov cs:word ptr font+2,ax
     mov cs:byte ptr charsize,dl
     popa
     ret

;---------------------
gettext:             ;>>CX,DX=char size ES:DI=font addres
     push ax
     mov cl,cs:byte ptr charx
     mov dl,cs:byte ptr chary
     mov di,cs:word ptr font
     mov ax,cs:word ptr font+2
     mov es,ax
     pop ax
     ret

;---------------------
outtext:               ;ப  DS:SI
        pusha          ;CX,DX = Position
        pushf
        cld
m11:
        lodsb                   ;AL=DS:[SI]
        cmp al,0
        je m12
        mov bl,al
        call outchar
        movzx ax,cs:byte ptr charx
        add cx,ax
        jmp m11

m12:    popf
        popa
        ret

;---------------------
outchar:             ;CX,DX=position BL=symbol
     pusha
     push es
     mov cs:word ptr w0,cx
     mov cs:word ptr w1,dx
     mov cs:word ptr w2,0
     mov cs:word ptr w3,0

     mov al,bl
     mul cs:byte ptr charsize
     add ax,cs:word ptr font
     mov di,ax
     mov ax,cs:word ptr font+2
     mov es,ax
m10:
     mov al,es:[di]
     mov bl,10000000b
     mov cl,cs:byte ptr w2
     shr bl,cl
     test al,bl
     jz m9

     mov cx,cs:word ptr w2
     mov dx,cs:word ptr w3
     add cx,cs:word ptr w0
     add dx,cs:word ptr w1
     call putpixel
m9:
     inc cs:byte ptr w2
     mov cl,cs:byte ptr w2
     cmp cl,cs:byte ptr charx
     jl m10
     inc cs:byte ptr w3
     mov cl,cs:byte ptr w3
     mov cs:byte ptr w2,0
     inc di
     cmp cl,cs:byte ptr chary
     jl m10

     pop es
     popa
     ret

;---------------Variables--------------
pi:    dq 3.14159265358979323846
pi2:   dq 1.57079632679489661923
pi_2:  dq 6.28318530717958647792

maxx:  dw 0
maxy:  dw 0
charx: db 0
chary: db 0
color: dw 0
font:  dd 0
drvadr: dd 0
charsize: db 0
bank:  db 0

q0:    dq 0
q1:    dq 0
q2:    dq 0
q3:    dq 0

w0:    dw 0
w1:    dw 0
w2:    dw 0
w3:    dw 0
w4:    dw 0
w5:    dw 0
w6:    dw 0

mmm:
     dw 10
     dw 8
     db 0,1,2,3,4,5,6,7,8,0
     db 0,0,1,2,3,4,5,6,7,0
     db 0,0,0,1,2,3,4,5,6,0
     db 0,0,0,0,1,2,3,4,5,0
     db 0,0,8,8,8,8,8,8,0,0
     db 0,0,8,0,0,0,0,8,0,0
     db 0,0,8,8,8,8,8,8,0,0
     db 0,0,0,0,0,0,0,0,0,0

txt: db 'Copyright (C) 1998 EXOS Technologies.',0

;--------------------------------Driver---------------------------------------
driver:
       cmp ax,0h
       jne d0
       call mputpixel256
       retf
d0:
       cmp ax,1h
       jne d1
       call mgetpixel256
       retf
d1:
       cmp ax,2h
       jne d2
       call swapbank
       retf
d2:
       cmp ax,10h
       jne d10
       call setvmode
       retf
d10:
       retf

swapbank:       ;AX=bank
      push bx
      cmp ax,cs:word ptr bank
      je dm5

      mov cs:word ptr bank,ax
      mov dx,ax
      push dx
      xor bx,bx           ;set frame no.0
      mov ax,4f05h        ;VESA frame function
      int 10h

      pop dx              ;restore bank
      mov bx,01           ;set frame no.1
      mov ax,4f05h        ;VESA frame function
      int 10h
dm5:
      mov ax,0A000h
      mov es,ax
      pop bx
      ret

swapcolor:      ;AH = Color
      push dx ax
      mov dx,3c4h
      mov al,02
      out dx,ax
      pop ax dx
      ret

setallcolor:
      push dx ax
      mov dx,3c4h
      mov ax,0f02h
      out dx,ax
      pop ax dx
      ret


mputpixel256:  ;256 color modes ;CX,DX = pixel  BX = color
     push eax si edx es
     movzx eax,cs:word ptr maxx
     mul edx             ;eDX  뢠
     add eax,ecx
     xor edx,edx
     push ebx
     mov ebx,65536
     div ebx
     pop ebx
     mov si,dx
     call swapbank
     mov es:[si],bx
     pop es edx si eax
     ret

mgetpixel256:  ;256 color modes ;CX,DX = pixel  >>BX = color
     push eax si edx es
     movzx eax,cs:word ptr maxx
     mul edx             ;eDX  뢠
     add eax,ecx
     xor edx,edx
     mov ebx,65536
     div ebx
     xor ebx,ebx
     mov si,dx
     call swapbank
     mov bx,es:[si]
     pop es edx si eax
     ret

;0 = B/W
;1 = 2 color
;2 = 4 color
;3 = 8 color
;4 = 16 color
;6 = 64 color
;8 = 256 color
;15 = 32K
;16 = 64K
;24 = 16.8M

setvmode:    ;CX,DX = Resolution Bl = Attribute
     push si
     mov ax,23
     lea si,modetable
dm1:
     cmp cx,cs:[si+3]
     jne dm2
     cmp dx,cs:[si+5]
     jne dm2
     cmp bl,cs:[si+7]
     jne dm2
     cmp cs:byte ptr [si+0],1
     je dm3
dm2:
     dec ax
     add si,8
     cmp ax,0
     jne dm1
     mov ax,1 ;Mode not supported
     pop si
     ret
dm3:
     mov bx,cs:[si+1]
     pop si
     mov ax,4f02h
     int 10h
     cmp ah,00
     je dm4
     mov ax,2 ;Hardware error
     ret
dm4:
     xor ax,ax ;No errors
     pop si
     ret

modetable:
mode <0,100h,640,400,8>;         640x400    256
mode <0,101h,640,480,8>;         640x480    256
mode <0,102h,800,600,4>;         800x600    16
mode <0,103h,800,600,8>;         800x600    256
mode <0,104h,1024,768,4>;        1024x768   16
mode <0,105h,1024,768,8>;        1024x768   256
mode <0,106h,1280,1024,4>;       1280x1024  16
mode <0,107h,1280,1024,8>;       1280x1024  256
mode <0,10Dh,320,200,15>;        320x200    32K
mode <0,10Eh,320,200,16>;        320x200    64K
mode <0,10Fh,320,200,24>;        320x200    16.8M
mode <0,110h,640,480,15>;        640x480    32K
mode <0,111h,640,480,16>;        640x480    64K
mode <0,112h,640,480,24>;        640x480    16.8M
mode <0,113h,800,600,15>;        800x600    32K
mode <0,114h,800,600,16>;        800x600    64K
mode <0,115h,800,600,24>;        800x600    16.8M
mode <0,116h,1024,768,15>;       1024x768   32K
mode <0,117h,1024,768,16>;       1024x768   64K
mode <0,118h,1024,768,24>;       1024x768   16.8M
mode <0,119h,1280,1024,15>;      1280x1024  32K
mode <0,11Ah,1280,1024,16>;      1280x1024  64K
mode <0,11Bh,1280,1024,24>;      1280x1024  16.8M
mode <0,120h,1600,1200,8>;       1600x1200  256
;-----------------------------------------------------------------------------
include vgaga.inc
include ega.inc

end body